Using Assembly System.Windows.Forms
Using Assembly System.Drawing
Using Namespace System.Windows.Forms
Using Namespace System.Drawing

$HideConsoleWindow = '[DllImport("user32.dll")]public static extern bool ShowWindow(IntPtr handle, int state);'
Add-Type -Name WPS -Member $HideConsoleWindow -Namespace CNS
[Void][CNS.WPS]::ShowWindow(([System.Diagnostics.Process]::GetCurrentProcess() | Get-Process).MainWindowHandle,0)

Set-PSReadlineOption -HistorySaveStyle SaveNothing

If($WPS = Get-Process | Where-Object -FilterScript {$_.ProcessName -Eq "powershell" -And $_.Id -Ne $PID} -EA 0){$WPS | Stop-Process -Force}

$ScriptPath = $PSScriptRoot
If(-Not$ScriptPath){$ScriptPath = [System.AppDomain]::CurrentDomain.BaseDirectory.TrimEnd('\')}

$ErrorActionPreference = 'SilentlyContinue'

$Font = @{
	Vdn12B = [Font]::New('Verdena',12,[FontStyle]'Bold')
	Vdn14B = [Font]::New('Verdena',14,[FontStyle]'Bold')
}

Function Network
{
	$NTW_WinForm = New-Object System.Windows.Forms.Form -Property @{
		ClientSize = '250,175'
		StartPosition = 'CenterScreen'
		FormBorderStyle = 'None'
		BackColor = '255,30,70,30'
		MinimizeBox = $False
		MaximizeBox = $False
		ControlBox = $False
		KeyPreview = $True
		ShowInTaskBar = $False
		Topmost = $True
	}
	
	$NTW_ToolTipp = New-Object System.Windows.Forms.ToolTip -Property @{
		IsBalloon = $False
		InitialDelay = 500
		ReshowDelay = 500
		ShowAlways = $True
		BackColor = '255,30,30,30'
		ForeColor = 'Lime'
	}
	
	$NTW_LabelExit = New-Object System.Windows.Forms.Label -Property @{
		Location = '210,5'
		Size = '35,35'
		AutoSize = $False
		Font = $Font.Vdn14B
		Text = "X"
		TextAlign = 'MiddleCenter'
		BackColor = '255,30,70,30'
		ForeColor = 'White'
		Cursor = 'Hand'
		Add_MouseHover = {$NTW_LabelExit.BackColor = 'Red'}
		Add_MouseLeave = {$NTW_LabelExit.BackColor = '255,30,70,30'}
		Add_Click = {
			$NTW_WinForm.Hide()
			[System.Environment]::Exit(0)
		}
	}
	
	$NTW_LabelBttn = New-Object System.Windows.Forms.Label -Property @{
		Location = '50,70'
		Size = '150,55'
		AutoSize = $False
		Font = $Font.Vdn12B
		Text = ""
		TextAlign = 'MiddleCenter'
		BackColor = 'Black'
		ForeColor = 'Silver'
		Cursor = 'Hand'
		Add_MouseHover = {$NTW_LabelBttn.ForeColor = 'Lime'}
		Add_MouseLeave = {$NTW_LabelBttn.ForeColor = 'Silver'}
		Add_Click = {
			$NetAdptName = (Get-NetAdapter).Name
			If ($NTW_LabelBttn.Text -Eq 'Trennen')
			{
				$NTW_LabelBttn.Text = 'Verbinden'
				Disable-NetAdapter "$NetAdptName" -Confirm:$False
				$NTW_ToolTipp.SetToolTip($NTW_LabelBttn, "Internetverbindung ist getrennt!`nKlicken, um Verbindung zu aktivieren.")
			}
			ElseIf ($NTW_LabelBttn.Text -Eq 'Verbinden')
			{
				$NTW_LabelBttn.Text = 'Trennen'
				Enable-NetAdapter "$NetAdptName" -Confirm:$False
				$NTW_ToolTipp.SetToolTip($NTW_LabelBttn, "Internetverbindung ist aktiv!`nKlicken, um Verbindung zu trennen.")
			}
		}
	}
	
	$NTW_GrBoxBttn = New-Object System.Windows.Forms.GroupBox -Property @{
		Location = '47,62'
		Size = '155,65'
		AutoSize = $False
	}
	
	[Void]$NTW_WinForm.Controls.AddRange(@(
	$NTW_LabelExit,
	$NTW_LabelBttn,
	$NTW_GrBoxBttn
	))
	
	$Script:NetAdptMCSt = (Get-NetAdapter).MediaConnectionState
	If ($NetAdptMCSt -Eq 'Connected')
	{
		$NTW_LabelBttn.Text = 'Trennen'
		$NTW_ToolTipp.SetToolTip($NTW_LabelBttn, "Internetverbindung ist aktiv!`nKlicken, um Verbindung zu trennen.")
	}
	ElseIf ($NetAdptMCSt -Ne 'Connected')
	{
		$NTW_LabelBttn.Text = 'Verbinden'
		$NTW_ToolTipp.SetToolTip($NTW_LabelBttn, "Internetverbindung ist getrennt!`nKlicken, um Verbindung zu aktivieren.")
	}
	
	$NTW_ToolTipp.SetToolTip($NTW_LabelExit, "Anwendung beenden`nTaste 'ESC'")
	
	$NTW_WinForm.Add_KeyDown(
	{
		If ($_.KeyCode -Eq 'Escape')
		{
			$NTW_WinForm.Hide()
			[System.Environment]::Exit(0)
		}
	})
	
	[Void]$NTW_WinForm.ShowDialog()
}

If((New-Object System.Security.Principal.WindowsPrincipal([System.Security.Principal.WindowsIdentity]::GetCurrent())).IsInRole(544))
{
	Network | Out-Null
}
Else
{
	$WpsExist = (Get-ChildItem -File "$ScriptPath\NTWps.ps1").Name
	If ($WpsExist -Eq "NTWps.ps1")
	{
		$ElevatedFile = "$ScriptPath\$WpsExist"
		$ElevatedProcess = New-Object System.Diagnostics.ProcessStartInfo "$ElevatedFile";
		$ElevatedProcess.Verb = "RunAs"
		[System.Diagnostics.Process]::Start($ElevatedProcess)
		[System.Environment]::Exit(0)
	}
}